﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinGanttView.UIElements;
using Infragistics.Win.UltraWinSchedule.TimelineView;
using Infragistics.Win.UltraWinSchedule;
using System.Drawing;

namespace GanttView
{
    public class MyDraw1 : IUIElementDrawFilter
    {
        public static Task ActiveTask;

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            TaskBarUIElement slot = drawParams.Element as TaskBarUIElement;


            if (drawPhase == DrawPhase.BeforeDrawBackColor && slot != null && slot.Task.StartDateTime <= DateTime.Today)
            {
                drawParams.AppearanceData.BackColor = Color.Pink;
                drawParams.AppearanceData.BackColor2 = Color.PaleVioletRed;
                drawParams.AppearanceData.BackGradientStyle = GradientStyle.ForwardDiagonal;
            }

            if (drawPhase == DrawPhase.BeforeDrawBackColor && slot != null && slot.Task.StartDateTime > DateTime.Today.AddDays(2))
            {
                drawParams.AppearanceData.BackColor = Color.LightPink;
                drawParams.AppearanceData.BackColor2 = Color.Yellow;
                drawParams.AppearanceData.BackGradientStyle = GradientStyle.ForwardDiagonal;
            }

            if (drawPhase == DrawPhase.BeforeDrawBackColor && slot != null && slot.Task.StartDateTime > DateTime.Today && slot.Task.EndDateTime < DateTime.Today.AddDays(1))
            {
                drawParams.AppearanceData.BackColor = Color.Green;
                drawParams.AppearanceData.BackColor2 = Color.Yellow;
                drawParams.AppearanceData.BackGradientStyle = GradientStyle.ForwardDiagonal;
            }


            if (drawPhase == DrawPhase.BeforeDrawBackColor && slot != null && slot.Task == ActiveTask)
            {
                drawParams.AppearanceData.BackColor = Color.Red;
                drawParams.AppearanceData.BackColor2 = Color.Yellow;
                drawParams.AppearanceData.BackGradientStyle = GradientStyle.ForwardDiagonal;
            }


            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            TaskBarUIElement slot = drawParams.Element as TaskBarUIElement;
            if (slot != null)
                return DrawPhase.BeforeDrawBackColor;
            else
                return DrawPhase.None;
        }
    }

}
